{ This demoprogram shows how to use the statistics functions implemented
  in ChroMathsome.
  There have been drawing functions implemented here.
  To use them, you need module Calculus.
  If you don't have this, remove the appropriate code from this file before compilation.
  The reader may do with this code whatever he/she desires except re-use for
  commercial purposes.
  Author: John Merrit (john.merrit@net4all.be)
  Release date: ...

  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
  WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

  If you find it useful then I would appreciate any of the following:

  *  Comments, Suggestions, Bug finds etc.
  *  If you improve the interface, please send me a copy of the changes.
  
What I do not want is messages starting with "I am new to Delphi...". 
I've tried to place comments so that these demonstration programs should be readable enough.
Write to me if you have found a problem, not if you have a problem
which can be answered by posting to the comp.lang.delphi.components
newsgroup or any of the mathematics/numerical analysis newsgroups.               }

unit Statist;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls, ExtCtrls;

type
    avector = array[1..1500] of extended;  { Storage for values of function to draw.}
  TForm1 = class(TForm)
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    Doit1: TMenuItem;
    Statistic1: TMenuItem;
    Regression1: TMenuItem;
    Mean1: TMenuItem;
    StdDeviation1: TMenuItem;
    N1: TMenuItem;
    Firstsecondthirdandfourthmoment1: TMenuItem;
    CoffofSkewness1: TMenuItem;
    CoffofKurtosis1: TMenuItem;
    Linear1: TMenuItem;
    Logarithmic1: TMenuItem;
    Exponential1: TMenuItem;
    Power1: TMenuItem;
    PolyRegression1: TMenuItem;
    Parabolic1: TMenuItem;
    Cubic1: TMenuItem;
    Exit1: TMenuItem;
    TestPeriod1: TMenuItem;
    Version1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    MultLinReg1: TMenuItem;
    TwoIndepVar1: TMenuItem;
    ThreeIndepVar1: TMenuItem;
    TestStatistic1: TMenuItem;
    PairedtStatistic1: TMenuItem;
    Chi1: TMenuItem;
    Sum1: TMenuItem;
    Draw1: TMenuItem;
    Graph1: TMenuItem;
    DrawPad: TPaintBox;
    MainMenu2: TMainMenu;
    Close1: TMenuItem;
    N4: TMenuItem;
    BestFit1: TMenuItem;
    procedure Mean1Click(Sender: TObject);
    procedure Moments(Sender: TObject);
    procedure Linear1Click(Sender: TObject);
    procedure Logarithmic1Click(Sender: TObject);
    procedure Exponential1Click(Sender: TObject);
    procedure Power1Click(Sender: TObject);
    procedure Parabolic1Click(Sender: TObject);
    procedure TestPeriod1Click(Sender: TObject);
    procedure Version1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure TwoIndepVar1Click(Sender: TObject);
    procedure ThreeIndepVar1Click(Sender: TObject);
    procedure Cubic1Click(Sender: TObject);
    procedure PairedtStatistic1Click(Sender: TObject);
    procedure Chi1Click(Sender: TObject);
    procedure Sum1Click(Sender: TObject);
    procedure Graph1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure DrawPadPaint(Sender: TObject);
    procedure BestFit1Click(Sender: TObject);

  private
    { Private declarations }
    procedure PlotAxes;
    procedure PlotGraph;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Statistc, Calculus; { -> Calculus if you want to draw a curve (see below)... }
{$R *.DFM}

procedure TForm1.TestPeriod1Click(Sender: TObject);
begin
    HowManyDaysDoIHaveToTestChroMathsome;
end;

procedure TForm1.Version1Click(Sender: TObject);
begin
     ChroMathsomeVersion;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
     Close;
end;

procedure TForm1.Sum1Click(Sender: TObject);
var x: extended;
begin
    x:= Sum([0,2]);
    Memo1.Lines.add('Sum: ' + floattostr(x));
end;

{ Calculate the mean of the data in Data.  
  Data is of type open array.
  This means that you just pass the array through to the function/procedure
  without first declaring the array as a separate variable.
  See Delphi help file for more information about this datatype.}
procedure TForm1.Mean1Click(Sender: TObject);
var DMean, Deviation: extended;
begin
    if Sender = Mean1 then
    begin
    DMean:= Mean([26,30,44,50,62,68,74]); { Here's the open array used. }
    Memo1.lines.add('Mean: ' + FloatTostr(DMean))
    end
    else if Sender = StdDeviation1 then
    begin
    Deviation:= StdDev([26,30,44,50,62,68,74]);
    Memo1.lines.add('Standard deviation: ' + FloatTostr(Deviation));
    end;
end;

{ Calculate the 1st, 2nd, 3rth and 4th moments and the cofficients of skewness and
  kurtosis for the data in Data.  }
procedure TForm1.Moments(Sender: TObject);
var M1, M2, M3, M4, Skew, Kurtosis: extended;
begin
    MomentSkewKurtosis([2.1,3.5,4.2,6.5,4.1,3.6,5.3,3.7,4.9], M1, M2, M3, M4, Skew, Kurtosis);
    if Sender = Firstsecondthirdandfourthmoment1 then
    Memo1.lines.add('Moments: ' + FloatTostr(M1) + ' ' + FloatTostr(M2) + ' ' + FloatTostr(M3) +
    ' ' + FloatTostr(M4))
    else if Sender = CoffofSkewness1 then
    Memo1.lines.add('Cofficient of skewness: ' + FloatTostr(skew))
    else if Sender = CoffofKurtosis1 then
    Memo1.lines.add('Cofficient of kurtosis: ' + FloatTostr(kurtosis));
end;

{ Calculate the coeffic. of a straight line (y = a + b*x) that fits the data supplied in X and Y
  The statistical data must be supplied within two arrays (X and Y).
  Your data is of the form (Xi, Yi).
  Don't forget that the dimensions of X and Y must be the same!!!  }
procedure TForm1.Linear1Click(Sender: TObject);
var a, b, r: extended;
begin
    CurveFitting(a,b,r,[40.5,38.6,37.9,36.2,35.1,34.6],[104.5,102,100,97.5,95.5,94], Linear);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Same but now for a logarithmic curve (y = a + b*ln(x)).    }
procedure TForm1.Logarithmic1Click(Sender: TObject);
var a, b, r: extended;
begin
    CurveFitting(a,b,r,[3,4,6,10,12],[1.5,9.3,23.4,45.8,60.1], Logarithmic);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Same but now for an exponential curve (y = a + e^(b*x)).    }
procedure TForm1.Exponential1Click(Sender: TObject);
var a, b, r: extended;
begin
    CurveFitting(a,b,r,[0.72,1.31,1.95,2.58,3.14],[2.16,1.61,1.16,0.85,0.5], Exponential);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Same but now for a power curve (y = a*x^b).    }
procedure TForm1.Power1Click(Sender: TObject);
var a, b, r: extended;
begin
    CurveFitting(a,b,r,[10,12,15,17,20,22,25,27,30,32,35],
                       [0.95,1.05,1.25,1.41,1.73,2,2.53,2.98,3.85,4.59,6.02], Power);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Let's see wich of the above curves fits the data best.
  The example data points are the same as the for the power curve above.  }
procedure TForm1.BestFit1Click(Sender: TObject);
var a, b, r: extended;
    CurveType: CurveFittingType;
begin
    CurveType:= BestFit(a,b,r,[10,12,15,17,20,22,25,27,30,32,35],
                       [0.95,1.05,1.25,1.41,1.73,2,2.53,2.98,3.85,4.59,6.02]);
    case CurveType of
    Linear:begin
           Memo1.Lines.add('Best fit is a straight line y = a + b*x with:');
           Memo1.Lines.add('a:= ' + FloatToStr(a));
           Memo1.Lines.add('b:= ' + FloatToStr(b));
           Memo1.Lines.add('r:= ' + FloatToStr(r));
           end;
    Exponential:begin
                Memo1.Lines.add('Best fit is an exponential curve y = a*exp(b*x) with:');
                Memo1.Lines.add('a:= ' + FloatToStr(a));
                Memo1.Lines.add('b:= ' + FloatToStr(b));
                Memo1.Lines.add('r:= ' + FloatToStr(r));
                end;
    Logarithmic:begin
                Memo1.Lines.add('Best fit is a logarithmic curve y = a + b*ln(x) with:');
                Memo1.Lines.add('a:= ' + FloatToStr(a));
                Memo1.Lines.add('b:= ' + FloatToStr(b));
                Memo1.Lines.add('r:= ' + FloatToStr(r));
                end;
    Power:begin
          Memo1.Lines.add('Best fit is a power curve y = a*x^b with:');
          Memo1.Lines.add('a:= ' + FloatToStr(a));
          Memo1.Lines.add('b:= ' + FloatToStr(b));
          Memo1.Lines.add('r:= ' + FloatToStr(r));
          end;
    end;
end;

{ Same but now for a parabolic curve (y = a + b*x + c*x).    }
procedure TForm1.Parabolic1Click(Sender: TObject);
var a, b, c, d, r: extended;
begin
    PolyRegression(a, b, c, d, r,[1,2,3,4,5,6,7],[5,12,34,50,75,84,128], Parabolic);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('c:= ' + FloatToStr(c));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Same but now for a cubic curve (y = a + b*x + c*x + d*x).    }
procedure TForm1.Cubic1Click(Sender: TObject);
var a, b, c, d, r: extended;
begin
    PolyRegression(a, b, c, d, r,[0.8,1,1.2,1.4,1.6],[24,20,10,13,12], Cubic);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('c:= ' + FloatToStr(c));
    Memo1.Lines.add('d:= ' + FloatToStr(d));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Calculate the coeffic. a, b, c so that the data supplied in statistical vectors X, Y, T fits
  t = a + b*x + c*y.
  This is a linear equation in two independent variables.
  The technique is called Multiple Linear Regression.                                    }
procedure TForm1.TwoIndepVar1Click(Sender: TObject);
var a, b, c, r: extended;
begin
    MultiLinearRegression1(a,b,c,r,[1.5,0.45,1.8,2.8],[0.7,2.3,1.6,4.5],[2.1,4,4.1,9.4]);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('b:= ' + FloatToStr(c));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Same but now for three independent variables.
  The equation: t = a + b*x + c*y + d*z.           }
procedure TForm1.ThreeIndepVar1Click(Sender: TObject);
var a, b, c, d, r: extended;
begin
    MultiLinearRegression2(a,b,c,d,r,[7,1,11,11,7],[25,29,56,31,52],[6,15,8,8,6],[60,52,20,47,33]);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('c:= ' + FloatToStr(c));
    Memo1.Lines.add('d:= ' + FloatToStr(d));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Given a set of paired observations from two normal populations X and Y with unknown means 1 and 2,
  the test statistic t can be used to test the null hypothesis: 1 = 2.              }
procedure TForm1.PairedtStatistic1Click(Sender: TObject);
var t: extended;
begin
    t:= PairedtStatistic([14,17.5,17,17.5,15.4],[17,20.7,21.6,20.9,17.2]);
    Memo1.Lines.add('t:= ' + FloatToStr(t));
end;

{ Find the value of the chi-square statistic for the goodness of fit for the following
  set of data ...                                                                       }
procedure TForm1.Chi1Click(Sender: TObject);
var chi: extended;
begin
    chi:= ChiSquareStatistic([8,50,47,56,5,14],[9.6,46.75,51.85,54.4,8.25,9.15]);
    Memo1.Lines.add('chi:= ' + FloatToStr(chi));
end;

{ Let's see how good the calculated curve fits the original data.
  As an example, we'll use the linear regression for an exponential curve (see above).
  First, we'll plot the original data points.
  Next, we'll add the calculated curve.
  To use this feature, you need module Calculus.
  Before altering the code below, read the comments in the demonstration program for the
  calculus functions.
  Notes:
  - If the user resizes the window, the graph will adjust itself, i.e. will be redrawn with new
    scale-factors.
  - Be carefull with resizing.
    The code written here only handles 1500 points (resolution 1500 * ... ) as a maximum.
    Eventually set avector (in the definition above) to a higher value.    }
procedure TForm1.PlotAxes;
var x, y, i: integer;
begin
     x:= DrawPad.width;
     y:= DrawPad.height;
     with DrawPad.Canvas do
     begin
     Pen.Color := clGreen;
     for i:= 1 to x - 1 do
     begin
     moveto(i,Round(y/2));
     lineto(i+1,Round(y/2));
     end;
     for i:= 1 to y - 1 do
     begin
     moveto(Round(x/2),i);
     lineto(Round(x/2),i+1);
     end;
     end;
end;

procedure TForm1.Graph1Click(Sender: TObject);
begin
      Form1.Menu:= MainMenu2;
      Memo1.visible:= false;
      DrawPad.Visible:= true;
end;

{ Now we draw the data points and the calculated curve.
  Note that, for the parabolic curve, the fit was so good that we needed to draw the curve first
  and then the data points.
  This can, of course, be done for any curve.                                      }
procedure TForm1.PlotGraph;
var ScaleX, ScaleY, i, x, y: integer;
    a, b, c, d, r, fx : extended;
    F, Sa, Sb, Sc: string;
    v: ^avector;
begin
     new(v);
     x:= DrawPad.width;
     y:= DrawPad.height;
     ScaleX:= Round(y/10);
     ScaleY:= Round(y/10);
     try
     { Exponential curve... }
     CurveFitting(a,b,r,[0.72,1.31,1.95,2.58,3.14],[2.16,1.61,1.16,0.85,0.5], Exponential);
     Sa:= FloatToStr(a);
     Sb:= FloatToStr(b);
     F:= Sa + '*exp(' + Sb + '*x)';
     { x:= 0 at 1/2 width drawpad. fx = x- value where function needs to be evaluated. }
     for i:= 1 to x - 1 do
     begin
     fx:= (i - x/2)/ScaleY;
     v^[i]:= FunctionValue(F, fx);
     end;
     with DrawPad.Canvas do
     begin
     Color:= clBlack;
     Pixels[round((x/2 + 0.72*ScaleX)),round(y/2 - 2.16*ScaleY)]:= clYellow;
     Pixels[round((x/2 + 1.31*ScaleX)),round(y/2 - 1.61*ScaleY)]:= clYellow;
     Pixels[round((x/2 + 1.95*ScaleX)),round(y/2 - 1.16*ScaleY)]:= clYellow;
     Pixels[round((x/2 + 2.58*ScaleX)),round(y/2 - 0.85*ScaleY)]:= clYellow;
     Pixels[round((x/2 + 3.14*ScaleX)),round(y/2 - 0.5*ScaleY)]:= clYellow;
     Pen.Color := clRed;
     for i:= 1 to x - 2 do
     begin
     { x:= 0 at 1/2 width drawpad. fx = x- value where function needs to be evaluated. }
     moveto(i,Round(y/2 - ScaleY*v^[i]));
     lineto(i+1,Round(y/2 - ScaleY*v^[i+1]));
     end;
     end;

     { Parabolic curve... }
     F:= '';
     PolyRegression(a, b, c, d, r,[0.1,0.4,0.5,0.7,0.7,0.9],[0.61,0.92,0.99,1.52,1.47,2.03], Parabolic);
     Sa:= FloatToStr(a);
     Sb:= FloatToStr(b);
     Sc:= FloatToStr(c);
     F:= Sa + '+' + Sb + '*x+' + Sc + '*x*x';
     { x:= 0 at 1/2 width drawpad. fx = x- value where function needs to be evaluated. }
     for i:= 1 to x - 1 do
     begin
     fx:= (i - x/2)/ScaleY;
     v^[i]:= FunctionValue(F, fx);
     end;
     with DrawPad.Canvas do
     begin
     Pen.Color := clBlue;
     for i:= 1 to x - 2 do
     begin
     { x:= 0 at 1/2 width drawpad. fx = x- value where function needs to be evaluated. }
     moveto(i,Round(y/2 - ScaleY*v^[i]));
     lineto(i+1,Round(y/2 - ScaleY*v^[i+1]));
     end;
     Pixels[round((x/2 + 0.1*ScaleX)),round(y/2 - 0.61*ScaleY)]:= clWhite;
     Pixels[round((x/2 + 0.4*ScaleX)),round(y/2 - 0.92*ScaleY)]:= clWhite;
     Pixels[round((x/2 + 0.5*ScaleX)),round(y/2 - 0.99*ScaleY)]:= clWhite;
     Pixels[round((x/2 + 0.7*ScaleX)),round(y/2 - 1.52*ScaleY)]:= clWhite;
     Pixels[round((x/2 + 0.7*ScaleX)),round(y/2 - 1.47*ScaleY)]:= clWhite;
     Pixels[round((x/2 + 0.9*ScaleX)),round(y/2 - 2.03*ScaleY)]:= clWhite;
     end;
     finally
     dispose(v);
     end;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
    Memo1.Visible:= true;
    Drawpad.Visible:= false;
    Form1.Menu:= MainMenu1;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
     Memo1.Visible:= true;
     Drawpad.Visible:= false;
     Form1.Menu:= MainMenu1;
end;

procedure TForm1.DrawPadPaint(Sender: TObject);
begin
    PlotAxes;
    PlotGraph;
end;

end.
